//Program to receive a number on serial port and blink the right number of time. By Francis Lance april 2019.
#include <SoftwareSerial.h>
SoftwareSerial mySerial(0, 1); // RX, TX
int const SLAVEDEVICEID = 1; // Slave ID
int const LEDPIN = 3; // Pin for the LED
int const BLINKDELAY = 250; // Delay between blink of the LED
int numberOfBlink = 0; // Variable to store my number
char c = 'a'; // Received character
char ReceivedStringChar[] = "123"; // store each received character in this array (size is 4)
char slaveIDChar[] = "123"; // store each slave ID character in this array (size is 4)
char numberOfBlinkChar[] = "123"; // store each number of blink character in this array (size is 4)
int i=0; // Array index
int SlaveID = 0; //  Received Slave ID
int searchIndex = 0; // Index for the research in the char array
void setup() {
  mySerial.begin(9600); // Initialize serial port
  pinMode(LEDPIN, OUTPUT);
  digitalWrite(LEDPIN, HIGH);
}
void loop() { // run over and over

 while (mySerial.available()) { // While characters are ready to read in the serial buffer
    delay(2); // This delay is very important because it gives time to the characters 
              //to put themselves in the buffer. Without this delay, you will miss 
              //some characters.
    c = mySerial.read(); // Read the character in the buffer
    ReceivedStringChar[i] = c; // Insert the character in the array.
    i++; // Move the array index for the next character.
 }
 
 if (i >0) { // if we read some characrers
    ReceivedStringChar[i] ='\0'; // Insert the NUL character at the end of the array
    i=0; // Reset the index at the begenning
    searchIndex = 0; // Reset the search index at the begenning
    mySerial.println(ReceivedStringChar); // ECHO on the line. Transmit to the next slave.
    
    while(ReceivedStringChar[searchIndex] != ' ') // Find the first part of the message (Slave ID)
    {
      slaveIDChar[i] = ReceivedStringChar[searchIndex]; // Copy the character in the variable
      i++; // next index
      searchIndex++; // next search index
    }
    slaveIDChar[i] ='\0'; 
    i=0;// Reset the index at the begenning
    searchIndex++; // next search index

    
    while(ReceivedStringChar[searchIndex] != '\0') // Find the second part of the message (number of blink)
    {
      numberOfBlinkChar[i] = ReceivedStringChar[searchIndex];  // Copy the character in the variable
      i++; // next index
      searchIndex++; // next search index
    }
    searchIndex = 0; // Reset the search index for the next search.
   
    numberOfBlinkChar[i] ='\0'; // Insert the NUL character at the end of the slave ID
    SlaveID = atoi(slaveIDChar); // Convert the array in integer
    numberOfBlink = atoi(numberOfBlinkChar); // Convert the array in integer
    ReceivedStringChar[0]='\0'; // Reset the array
    i=0;// Reset the index at the begenning

    if (SlaveID == SLAVEDEVICEID) // if the message is for this slave.
    {
      for( int j = 0; j < numberOfBlink; j++){ // for the number a receive of time, blink the LED
        digitalWrite(LEDPIN, LOW);   // turn the LED on (LOW is the voltage level)
        delay(BLINKDELAY);    // wait for a half second
        digitalWrite(LEDPIN, HIGH);    // turn the LED off (HIGH is the voltage level)
        delay(BLINKDELAY);    // wait for a half second
        
      }
    }
  } 
}
